<template>
  <header>
    <div class="header-portrait portrait">
      <div class="left-header">
        <button @click="$emit('toggle-sidebar')" class="btn-menu">
          <img :src="require(`../assets/img/menu${sidebar ? '_active' : ''}.png`)" alt="menu" />
        </button>
      </div>
      <div class="logo">
        <img src="../assets/img/logo.png" />
      </div>
      <div class="right-header">
        <button class="btn-right-menu" @click="toggleLoginModal(true)">
          <img src="../assets/img/sign_in.png" alt="menu" />
        </button>
      </div>
    </div>
    <div class="header-landscape landscape">
      <img src="../assets/img/logo.png" class="logo" />
      <div class="side-btn">
        <button @click="toggleLoginModal(true)">
          <span>Sign in</span>
          <img src="../assets/img/sign_in.png" alt="menu" />
        </button>
        <button @click="$emit('toggle-sidebar')">
          <span :class="sidebar ? 'menu-active' : ''">Menu</span>
          <img :src="require(`../assets/img/menu${sidebar ? '_active' : ''}.png`)" alt="menu" />
        </button>
      </div>
    </div>
  </header>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'nuxt-property-decorator';
import { commonModule, Orientation } from '../store/common/const';

@Component
export default class HeaderComponent extends Vue {
  protected Orientation = Orientation;

  @Prop({ type: Boolean, default: false }) sidebar!: boolean;

  @commonModule.State('orientation') orientation!: Orientation;

  @commonModule.Action('toggleLoginModal')
  toggleLoginModal!: (isOpen: boolean) => void;
}
</script>

<style lang="scss" scoped>
header {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  z-index: 999;

  button {
    background-color: transparent;
    border: none;
    outline: none;

    &:hover {
      cursor: pointer;
    }
  }

  .header-portrait {
    display: flex;
    flex-direction: row;
    align-items: stretch;
    justify-content: space-between;
    height: 8%;
    background: url('../assets/img/line_top.png') no-repeat center center;
    background-size: 100% 100%;

    .btn-menu,
    .btn-right-menu {
      padding: 10px 20px;

      img {
        width: 100%;
        max-width: 20px;
      }
    }

    .btn-menu {
      text-align: left;
      padding: 10px 20px;
    }

    .btn-right-menu {
      text-align: right;
      padding: 10px 20px;
    }

    .left-header,
    .right-header {
      flex: 1;

      button {
        border: none;
        background-color: transparent;
        display: block;
        width: 100%;
        height: 100%;
        font-size: 1rem;
        outline: none;

        &:hover {
          cursor: pointer;
        }
      }
    }

    .logo {
      flex: 2;
      display: flex;
      justify-content: center;
      align-items: center;

      img {
        width: 50%;
        max-height: 30px;
        object-fit: contain;
      }
    }
  }

  @include Orientation(Landscape) {
    .header-landscape {
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
      background: linear-gradient(
        180deg,
        rgba(0, 0, 0, 1) 50%,
        rgba(0, 0, 0, 0) 100%
      );
      height: 13vh;

      .logo {
        height: 35%;
        padding-left: 5vh;
        object-fit: contain;
      }

      .side-btn {
        height: 100%;
        display: flex;
        flex: 1;
        flex-direction: row;
        justify-content: flex-end;
        align-items: stretch;

        .menu-active {
          color: $primary;
        }

        button {
          font-family: 'Montserrat', sans-serif;
          color: white;
          text-transform: uppercase;
          font-style: italic;
          height: 100%;
          display: flex;
          flex-direction: row;
          justify-content: center;
          align-items: center;
          font-size: 2vh;
          margin-right: 3vh;

          img {
            margin-left: 2vh;
            height: 35%;
            width: 20%;
            object-fit: contain;
          }
        }
      }
    }
  }
}
</style>